/*
FILE
	$Id: mainfunc.h 56 2006-09-07 21:49:12Z root $
PURPOSE
	Commandline interface.
AUTHOR
	GPL License applies, see www.fsf.org for details.
	See LICENSE file in this distribution.
	(C) 2001-2004 Gary Wallis.
TODO
	The menu is a mess. Use standard mysqlISP menu structure.
	Exits?
	ConnectDb?
*/


static char cTableList[32][32]=\
{"tZone","tResource","tRRType","tJob","tNameServer","tMailServer","tClient","tAuthorize","tConfiguration",""};


char cInitTableList[32][32]={"tRRType","tNameServer","tConfiguration","tMailServer",""};

void ExtMainShell(int argc, char *argv[]);
void Initialize(char *cPasswd);
void Backup(char *cPasswd);
void Restore(char *cPasswd, char *cTableName);
void RestoreAll(char *cPasswd);
void mySQLRootConnect(char *cRootPasswd);



void Tutorial(void);
void NamedConf(void);
void Admin(void);
void ListZones(void);

//bind.c
void Import(void);
void PrintNSList(FILE *zfp,char *cuNameServer);
void PrintMXList(FILE *zfp,char *cuMailServer);
void CreateWebZone(char *cDomain, char *cIP, char *cNameServer, char *cMailServer);
void DropZone(char *cDomain, char *cNameServer);

void ConnectMysqlServer(void);
void PassDirectHtml(char *file);

void GetConfiguration(const char *cName, char *cValue, unsigned uHtml);

int ExtMainCommands(pentry entries[], int x)
{
	if(!strcmp(function,"MainTools"))
	{
		if(!strcmp(command,"Tutorial"))
		{
			Tutorial();
		}
		else if(!strcmp(command,"NamedConf"))
		{
			NamedConf();
		}
		else if(!strcmp(command,"Admin"))
		{
			Admin();
		}
		else if(!strcmp(command,"Import"))
		{
			Import();
		}

	}

	return(0);
}

void ExtMainContent(void)
{
        printf("<p><input type=hidden name=gcFunction value=MainTools>");

        OpenFieldSet("System Information",100);

        OpenRow("Hostname","black");
        printf("<td>%s</td></tr>\n",gcHostname);

        OpenRow("Build Information","black");
        printf("<td>%s</td></tr>\n",gcBuildInfo);

        OpenRow("RAD Status","black");
        printf("<td>%s</td></tr>\n",gcRADStatus);

        OpenRow("Application Summary","black");
        printf("<td>myqslBind webconsole to manage multiple DNS/BIND (8 and 9) name servers.</td></tr>\n");
        if(uPermLevel>9)
	{
                register unsigned int i;
                OpenRow("Table List","black");
                printf("<td>\n");
                for(i=0;cTableList[i][0];i++)
                	printf("<a href=mysqlBind.cgi?function=%.32s>%.32s</a><br>\n",
				cTableList[i],cTableList[i]);
		printf("</td></tr>\n");

        	OpenRow("Admin Functions","black");
		printf("<td><input type=hidden name=function value=MainTools>\n");
		printf("<input class=largeButton type=submit name=command value=Admin></td></tr>\n");
	}

																				
        CloseFieldSet();

}//void ExtMainContent(void)

//If called from command line
//In bind.c
void CreateMasterFiles(char *cMasterNS, char *cZone, 
		unsigned uModDBFiles, unsigned uModStubs);
void CreateSlaveFiles(char *cSlaveNS,char *cZone,char *cMasterIP);
void InstallNamedFiles(char *cIpNum);
void Initialize(char *cPasswd);
void ExportTable(char *cTable, char *cFile);
void SlaveJobQueue(char *cNameServer, char *cMasterIP);
void MasterJobQueue(char *cNameServer);
void ProcessExtJobQueue(char *cServer);//bind.c

void PrintUsage(char *arg0)
{
	printf("\n%s %s Menu (C) 2001-2006 Gary Wallis\n\nDatabase Ops:\n"
					,arg0,RELEASE);
	printf("\tInitialize <mysql root passwd>\n");
	printf("\tBackup|RestoreAll [<mysql root passwd>]\n");
	printf("\tRestore <Restore table name> [<mysql root passwd>]\n");
	printf("\nCrontab Ops:\n");
	printf("\tProcessJobQueue <FQDN Server>\n");
	printf("\tProcessExtJobQueue <Server as in mysqlISP>\n");
	printf("\tjobqueue master <fqdn ns> (equivalent to ProcessJobQueue)\n");
	printf("\tjobqueue slave <fqdn ns> <master ip>\n");
	printf("\nSpecial Admin Ops:\n");
	printf("\tallfiles master|slave <fqdn ns> <master ip>\n");
	printf("\tinstallbind <listen ipnum>\n");
	printf("\texport <table> <filename>\n");
	printf("\tListZones\n");
	printf("\tPrintNSList <cuNameServer>\n");
	printf("\tPrintMXList <cuMailServer>\n");
	printf("\tCreateWebZone <cDomain> <cIP> [<cNameServer group label> <cMailServer group label>]\n");
	printf("\tDropZone <cDomain> [<cNameServer group label>]\n");
	printf("\n");
	exit(0);

}//void PrintUsage(char *arg0)


void ExtMainShell(int argc, char *argv[])
{
	if(getuid())
	{
		printf("Sorry! must be root to run mysqlBind.cgi command line\n");
		exit(1);
	}

	if(argc==2)
	{
		if(!strcmp(argv[1],"Backup"))
		{
                	Backup("");
			exit(0);
		}
		else if(!strcmp(argv[1],"ListZones"))
		{
                	ListZones();
		}
        	else if(!strcmp(argv[1],"RestoreAll"))
		{
                	RestoreAll("");
		}
	}
	else if(argc==3)
	{
		if(!strcmp(argv[1],"ProcessJobQueue"))
		{
			MasterJobQueue(argv[2]);
		}
		else if(!strcmp(argv[1],"ProcessExtJobQueue"))
		{
			ProcessExtJobQueue(argv[2]);
			exit(0);
		}
		else if(!strcmp(argv[1],"installbind"))
		{
			InstallNamedFiles(argv[2]);
		}
		else if(!strcmp(argv[1],"Initialize"))
		{
			Initialize(argv[2]);
		}
		else if(!strcmp(argv[1],"Backup"))
		{
                	Backup(argv[2]);
			exit(0);
		}
        	else if(!strcmp(argv[1],"RestoreAll"))
		{
                	RestoreAll(argv[2]);
		}
        	else if(!strcmp(argv[1],"Restore"))
		{
                	Restore(argv[2],"");
			exit(0);
		}
		else if(!strcmp(argv[1],"PrintNSList"))
		{
			ConnectDb();
                	PrintNSList(stdout,argv[2]);
			exit(0);
		}
		else if(!strcmp(argv[1],"PrintMXList"))
		{
			ConnectDb();
                	PrintMXList(stdout,argv[2]);
			exit(0);
		}
		else if(!strcmp(argv[1],"DropZone"))
		{
			ConnectDb();
			DropZone(argv[2],"");
			exit(0);
		}
		PrintUsage(argv[0]);
	}
	else if(argc==4)
	{
		if(!strcmp(argv[1],"jobqueue"))
		{
			if(!strcmp(argv[2],"master"))
				MasterJobQueue(argv[3]);
		}
		else if(!strcmp(argv[1],"export"))
		{
			ExportTable(argv[2],argv[3]);
		}
        	else if(!strcmp(argv[1],"Restore"))
		{
                	Restore(argv[3],argv[2]);
			exit(0);
		}
		else if(!strcmp(argv[1],"CreateWebZone"))
		{
			ConnectDb();
			CreateWebZone(argv[2],argv[3],"","");
			exit(0);
		}
		else if(!strcmp(argv[1],"DropZone"))
		{
			ConnectDb();
			DropZone(argv[2],argv[3]);
			exit(0);
		}
		PrintUsage(argv[0]);
	}
	else if(argc==5)
	{
		if(!strcmp(argv[1],"allfiles"))
		{
			if(!strcmp(argv[2],"slave"))
			{
				ConnectMysqlServer();
				CreateSlaveFiles(argv[3],"",argv[4]);//All
			}
			else if(!strcmp(argv[2],"master"))
			{
				ConnectDb();
				//All+DBFiles+Stubs
				CreateMasterFiles(argv[3],"",1,1);
			}
#ifdef BIND9
			system("/usr/sbin/rndc reload");
#else
			system("/usr/sbin/ndc -c /var/run/ndc-mysqlbind reload");
#endif
			exit(0);
		}
		else if(!strcmp(argv[1],"jobqueue"))
		{
			if(!strcmp(argv[2],"slave"))
				SlaveJobQueue(argv[3],argv[4]);
		}
		else if(!strcmp(argv[1],"CreateWebZone"))
		{
			ConnectDb();
			CreateWebZone(argv[2],argv[3],argv[4],"");
			exit(0);
		}
		PrintUsage(argv[0]);
	}
	else if(argc==6)
	{
		if(!strcmp(argv[1],"CreateWebZone"))
		{
			ConnectDb();
			CreateWebZone(argv[2],argv[3],argv[4],argv[5]);
			exit(0);
		}
		PrintUsage(argv[0]);
	}
	PrintUsage(argv[0]);


}//void ExtMainShell(int argc, char *argv[])


void Tutorial(void)
{
	Header_ism3("Tutorial",0);
	printf("</center><blockquote>");
	PassDirectHtml("mysqlbind.tutorial.txt");
	printf("</blockquote>");
	Footer_ism3();
}//void Tutorial(void)


void NamedConf(void)
{
	Header_ism3("NamedConf()",0);
	printf("</center><pre><blockquote>");
	PassDirectHtml("/usr/local/mysqlbind/named.conf");
	printf("</blockquote></pre>");
	Footer_ism3();
}//void NamedConf(void)


void Admin(void)
{
	Header_ism3("Admin",0);
	printf("<table width=900><tr><td>");
	printf("<form action=mysqlBind.cgi method=post>");
	
	printf("<input type=hidden name=function value=MainTools>");

	if(uPermLevel > 7 )
	{
		printf("<input title='View this systems named.conf file' class=largeButton type=submit name=command value=NamedConf><br>");
	}

	if(uPermLevel > 9 )
	{
		printf("<input title='Import zone data from existing named system' class=lwarnButton type=submit name=command value=Import><br>");
	}
	
	printf("</td></tr></table></form>");
	Footer_ism3();

}//void NamedConf(void)




void RestoreAll(char *cPasswd)
{
	char cISMROOT[256]={""};

	if(getenv("ISMROOT")!=NULL)
	{
		strncpy(cISMROOT,getenv("ISMROOT"),255);
		cHost[255]=0;
	}

	if(!cISMROOT[0])
	{
		printf("You must set ISMROOT env var first. Ex. (bash) export ISMROOT=/home/ism-3.0\n");
	exit(1);
	}

	printf("Restoring mysqlBind data from .txt file in %s/{{cProject}}/data...\n\n",cISMROOT);

	//connect as root to master db
	mySQLRootConnect(cPasswd);

	sprintf(query,"use %s",DBNAME);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}

	for(i=0;cTableList[i][0];i++)
	{
sprintf(query,"load data infile '%s/mysqlBind/data/%s.txt' replace into table %s",cISMROOT,cTableList[i],cTableList[i]);
		mysql_query(&mysql,query);
		if(mysql_errno(&mysql))
		{
			printf("%s\n",mysql_error(&mysql));
			exit(1);
		}
		printf("%s\n",cTableList[i]);
	}

	printf("\nDone\n");

}//void RestoreAll(char *cPasswd)


void Restore(char *cPasswd, char *cTableName)
{
	char cISMROOT[256]={""};

	if(getenv("ISMROOT")!=NULL)
	{
		strncpy(cISMROOT,getenv("ISMROOT"),255);
		cHost[255]=0;
	}

	if(!cISMROOT[0])
	{
		printf("You must set ISMROOT env var first. Ex. (bash) export ISMROOT=/home/ism-3.0\n");
	exit(1);
	}

	printf("Restoring mysqlBind data from .txt file in %s/{{cProject}}/data...\n\n",cISMROOT);

	//connect as root to master db
	mySQLRootConnect(cPasswd);

	sprintf(query,"use %s",DBNAME);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}

	sprintf(query,"load data infile '%s/mysqlBind/data/%s.txt' replace into table %s",cISMROOT,cTableName,cTableName);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}

	printf("%s\n\nDone\n",cTableName);

}//void Restore(char *cPasswd, char *cTableName)


void Backup(char *cPasswd)
{
	char cISMROOT[256]={""};

	if(getenv("ISMROOT")!=NULL)
	{
		strncpy(cISMROOT,getenv("ISMROOT"),255);
		cHost[255]=0;
	}

	if(!cISMROOT[0])
	{
		printf("You must set ISMROOT env var first. Ex. (bash) export ISMROOT=/home/ism-3.0\n");
	exit(1);
	}

	printf("Backing up mysqlBind data to .txt files in \
%s/mysqlBind/data...\n\n",cISMROOT);

	//connect as root to master db
	mySQLRootConnect(cPasswd);

	sprintf(query,"use %s",DBNAME);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}

	for(i=0;cTableList[i][0];i++)
	{
		char cFileName[300];

		sprintf(cFileName,"%s/mysqlBind/data/%s.txt"
				,cISMROOT,cTableList[i]);
		unlink(cFileName);

sprintf(query,"SELECT * INTO OUTFILE '%s' FROM %s",cFileName,cTableList[i]);
		mysql_query(&mysql,query);
		if(mysql_errno(&mysql))
		{
			printf("%s\n",mysql_error(&mysql));
			exit(1);
		}
		printf("%s\n",cTableList[i]);
	}


	printf("\nDone.\n");

}//void Backup(char *cPasswd)


void Initialize(char *cPasswd)
{
	char cISMROOT[256]={""};
	char cCGIDIR[256]={""};
	time_t clock;

	if(getenv("ISMROOT")!=NULL)
	{
		strncpy(cISMROOT,getenv("ISMROOT"),255);
		cISMROOT[255]=0;
	}

	if(!cISMROOT[0])
	{
		printf("You must set ISMROOT env var first. Ex. (bash) export ISMROOT=/home/joe\n");
		exit(1);
	}

	if(getenv("CGIDIR")!=NULL)
	{
		strncpy(cCGIDIR,getenv("CGIDIR"),255);
		cCGIDIR[255]=0;
	}

	if(!cCGIDIR[0])
	{
		printf("You must set CGIDIR env var first. Ex. (bash) export CGIDIR=/admin/cgi-bin/ (Note the trailing /)\n");
		exit(1);
	}

	printf("Creating db and setting permissions, installing data from %s/mysqlBind...\n\n",cISMROOT);

	//connect as root to master db
	mySQLRootConnect(cPasswd);

	//Create database
	
	sprintf(query,"CREATE DATABASE %s",DBNAME);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}

	//Grant localaccess privileges.
	sprintf(query,"GRANT ALL ON %s.* to %s@localhost identified by '%s'",
			DBNAME,DBLOGIN,DBPASSWD);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}
	
	//Change to mysqlbind db. Then initialize some tables with needed data
	sprintf(query,"USE %s",DBNAME);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}
	
	
	time(&clock);
	
	CreatetAuthorize();
	//And 3 standard example users
	sprintf(query,"INSERT INTO tAuthorize SET cLabel='Root',uCertClient=1,cIpMask='0.0.0.0',uPerm=12,uOwner=1,uCreatedBy=1,uCreatedDate=%lu,cPasswd='..M0/uAvCFhis'",clock);
mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}

	CreatetClient();
	sprintf(query,"INSERT INTO tClient SET cLabel='Root',uOwner=1,uCreatedBy=1,uCreatedDate=%lu",clock);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}

	//Create tables and install default data
	CreatetZone();
	CreatetResource();
	CreatetRRType();
	CreatetNameServer();
	CreatetJob();
	CreatetMailServer();
	CreatetConfiguration();

        for(i=0;cInitTableList[i][0];i++)
        {
                sprintf(query,"load data infile '%s/mysqlBind/data/%s.txt' replace into table %s",cISMROOT,cInitTableList[i],cInitTableList[i]);
                mysql_query(&mysql,query);
                if(mysql_errno(&mysql))
                {
                        printf("%s\n",mysql_error(&mysql));
                        exit(1);
                }
        }

        sprintf(query,"cp $ISMROOT/mysqlBind/docs/tutorial.html $CGIDIR/mysqlbind.tutorial.txt");
	system(query);

        printf("Done\n");
	exit(0);

}//void Initialize(void)


void mySQLRootConnect(char *cRootPasswd)
{
	char cMySQLRootPwd[256]={""};
	char *cPasswd=NULL;


	if(cRootPasswd[0])
	{
		cPasswd=cRootPasswd;
	}
	else
	{
		ConnectDb();//using local.h compiled in info or mysqlbind.conf file
		GetConfiguration("cMySQLRootPwd",cMySQLRootPwd,0);
		mysql_close(&mysql);
		 if(cMySQLRootPwd[0])
			cPasswd=cMySQLRootPwd;
	}

        mysql_init(&mysql);
#ifdef USECONF
        if(!mysql_real_connect(&mysql,gcEffectiveDbIp,"root",cPasswd,
					"mysql",guDbPort,gcEffectiveDbSocket,0))
#else
        if (!mysql_real_connect(&mysql,DBIP,"root",cPasswd,"mysql",DBPORT,DBSOCKET,0))
#endif
        {
		if(mysql_errno(&mysql))
			fprintf(stderr,"%s\n",mysql_error(&mysql));

                fprintf(stderr,"Database server unavailable\n");
                exit(1);
        }

}//void mySQLRootConnect(char *cRootPasswd)

void ListZones(void)
{
	MYSQL_RES *res;
	MYSQL_ROW field;

	ConnectDb();

	sprintf(query,"SELECT cZone,cLabel FROM tZone,tNameServer WHERE tZone.uNameServer=tNameServer.uNameServer");
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) 
	{
		fprintf(stderr,"%s\n",mysql_error(&mysql));
		exit(1);
	}
	res=mysql_store_result(&mysql);
	while((field=mysql_fetch_row(res))) 
	{
		//printf("%s %s\n",field[0],field[1]);
		printf("%s\n",field[0]);
	}
	exit(0);

}//void ListZones(void)

// vim:tw=88
