/*
FILE
	tConfiguration source code of mysqlBind.cgi
	$Id: tconfiguration.c 39 2006-08-24 00:03:11Z hus $
PURPOSE
	Record operations code based on schema that may change. 
	Application code should be developed in tconfigurationfunc.h.
	This way we can seperate changing schema by RAD2 from application
	specific code.
NOTES
	Migrating to new look and feel. Will then use this experience
	to develop mmysqlRAD2 templates to finally make new mysqlRAD3.
*/

#include "mysqlrad.h"

//Table Variables
//uConfiguration: Primary Key
static unsigned uConfiguration=0;
//cLabel: Short label
static char cLabel[33]={""};
//cValue: Value of name(cLabel)/value pair
static char cValue[256]={""};
//cComment: Comment about this configuration name/value pair
static char *cComment={""};
//uOwner: Record owner
static unsigned uOwner=0;
//uCreatedBy: uClient for last insert
static unsigned uCreatedBy=0;
//uCreatedDate: Unix seconds date last insert
static long unsigned uCreatedDate=0;
//uModBy: uClient for last update
static unsigned uModBy=0;
//uModDate: Unix seconds date last update
static long unsigned uModDate=0;




#define VAR_LIST_tConfiguration "tConfiguration.uConfiguration,tConfiguration.cLabel,tConfiguration.cValue,tConfiguration.cComment,tConfiguration.uOwner,tConfiguration.uCreatedBy,tConfiguration.uCreatedDate,tConfiguration.uModBy,tConfiguration.uModDate"

 //Local only
void Insert_tConfiguration(void);
void Update_tConfiguration(char *rowid);
int InsertUpdate_tConfiguration(char *cKey);
void ProcesstConfigurationListVars(pentry entries[], int x);

 //In tConfigurationfunc.h file included below
void ExtProcesstConfigurationVars(pentry entries[], int x);
void ExttConfigurationCommands(pentry entries[], int x);
void ExttConfigurationButtons(void);
void ExttConfigurationNavBar(void);
void ExttConfigurationGetHook(entry gentries[], int x);
void ExttConfigurationSelect(void);
void ExttConfigurationSelectRow(void);
void ExttConfigurationListSelect(void);
void ExttConfigurationListFilter(void);
void ExttConfigurationAuxTable(void);

#include "tconfigurationfunc.h"

 //Table Variables Assignment Function
void ProcesstConfigurationVars(pentry entries[], int x)
{
	register int i;


	for(i=0;i<x;i++)
	{
		if(!strcmp(entries[i].name,"uConfiguration"))
			sscanf(entries[i].val,"%u",&uConfiguration);
		else if(!strcmp(entries[i].name,"cLabel"))
			sprintf(cLabel,"%.32s",entries[i].val);
		else if(!strcmp(entries[i].name,"cValue"))
			sprintf(cValue,"%.255s",entries[i].val);
		else if(!strcmp(entries[i].name,"cComment"))
			cComment=entries[i].val;
		else if(!strcmp(entries[i].name,"uOwner"))
			sscanf(entries[i].val,"%u",&uOwner);
		else if(!strcmp(entries[i].name,"uCreatedBy"))
			sscanf(entries[i].val,"%u",&uCreatedBy);
		else if(!strcmp(entries[i].name,"uCreatedDate"))
			sscanf(entries[i].val,"%lu",&uCreatedDate);
		else if(!strcmp(entries[i].name,"uModBy"))
			sscanf(entries[i].val,"%u",&uModBy);
		else if(!strcmp(entries[i].name,"uModDate"))
			sscanf(entries[i].val,"%lu",&uModDate);

	}

	//Debug only
	//mysqlBind(cLabel);

	//After so we can overwrite form data if needed.
	ExtProcesstConfigurationVars(entries,x);

}//ProcesstConfigurationVars()


void ProcesstConfigurationListVars(pentry entries[], int x)
{
        register int i;

        for(i=0;i<x;i++)
        {
                if(!strncmp(entries[i].name,"ED",2))
                {
                        sscanf(entries[i].name+2,"%u",&uConfiguration);
                        mode=6;
                        tConfiguration("");
                }
        }
}//void ProcesstConfigurationListVars(pentry entries[], int x)


int tConfigurationCommands(pentry entries[], int x)
{
	ProcessControlVars(entries,x);

	ExttConfigurationCommands(entries,x);

	if(!strcmp(function,"tConfigurationTools"))
	{
		if(!strcmp(find,LANG_NB_LIST))
		{
			tConfigurationList();
		}

		//Default
		ProcesstConfigurationVars(entries,x);
		tConfiguration("");
	}
	else if(!strcmp(function,"tConfigurationList"))
	{
		ProcessControlVars(entries,x);
		ProcesstConfigurationListVars(entries,x);
		tConfigurationList();
	}

	return(0);

}//tConfigurationCommands()


void tConfiguration(const char *result)
{
	MYSQL_RES *res;
	MYSQL_RES *res2;
	MYSQL_ROW field;

	//Internal skip reloading
	if(!result[0])
	{
		if(mode)
			ExttConfigurationSelectRow();
		else
			ExttConfigurationSelect();

		mysql_query(&mysql,query);
		if(mysql_errno(&mysql))
        	{
			if(strstr(mysql_error(&mysql)," doesn't exist"))
                	{
				CreatetConfiguration();
				mysqlBind("New tConfiguration table created");
                	}
			else
			{
				mysqlBind(mysql_error(&mysql));
			}
        	}

		res=mysql_store_result(&mysql);
		if((i=mysql_num_rows(res)))
		{
			if(mode==6)
			{
			sprintf(query,"SELECT _rowid FROM tConfiguration WHERE uConfiguration=%u"
						,uConfiguration);
			mysql_query(&mysql,query);
			res2=mysql_store_result(&mysql);
			field=mysql_fetch_row(res2);
			sscanf(field[0],"%lu",&rowid);
			rowid++;
			}
			PageMachine("",0,"");
			if(!mode) mysql_data_seek(res,rowid-1);
			field=mysql_fetch_row(res);
			sscanf(field[0],"%u",&uConfiguration);
			sprintf(cLabel,"%.32s",field[1]);
			sprintf(cValue,"%.255s",field[2]);
			cComment=field[3];
			sscanf(field[4],"%u",&uOwner);
			sscanf(field[5],"%u",&uCreatedBy);
			sscanf(field[6],"%lu",&uCreatedDate);
			sscanf(field[7],"%u",&uModBy);
			sscanf(field[8],"%lu",&uModDate);
		}

	}//Internal Skip

	Header_ism3(":: tConfiguration",0);
	//printf("<form action=mysqlBind.cgi method=post >\n");
	printf("<table width=100%% cellspacing=0 cellpadding=0>\n");
	printf("<tr><td colspan=2 align=right valign=center>");


	//ExttConfigurationNavBar();

	printf("<input type=hidden name=function value=tConfigurationTools>");
	printf("<input type=hidden name=rowid value=%lu>",rowid);
	if(i)
	{
		if(mode==6)
			//printf(" Found");
			printf(LANG_NBR_FOUND);
		else if(mode==5)
			//printf(" Modified");
			printf(LANG_NBR_MODIFIED);
		else if(mode==4)
			//printf(" New");
			printf(LANG_NBR_NEW);
		printf(LANG_NBRF_SHOWING,rowid,i);
	}
	else
	{
		if(!result[0])
		//printf(" No records found");
		printf(LANG_NBR_NORECS);
	}
	if(result[0]) printf("%s",result);
	printf("</td></tr>");
	printf("<tr><td valign=top width=25%%>");

        ExttConfigurationButtons();

        printf("</td><td valign=top>");
	OpenFieldSet("Record Data",100);
	//printf("<table width=100%% border=0 bgcolor=#9BC1B3 valign=center>\n");

	if(mode==2000 || mode==2002)
		tConfigurationInput(1);
	else
		tConfigurationInput(0);

	//printf("</table>\n");
	//printf("</table>\n");
	CloseFieldSet();

	//Bottom table
        //ExttConfigurationAuxTable();

	Footer_ism3();

}//end of tConfiguration();


void tConfigurationInput(unsigned uMode)
{

	//uConfiguration
	OpenRow(LANG_FL_tConfiguration_uConfiguration,"black");
	printf("<input title='%s' type=text name=uConfiguration value=%u size=16 maxlength=10 ",LANG_FT_tConfiguration_uConfiguration,uConfiguration);
	if(uPermLevel>=20 && uMode)
	{
		printf("></td></tr>\n");
	}
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=uConfiguration value=%u>\n",uConfiguration);
	}

	//cLabel
	OpenRow(LANG_FL_tConfiguration_cLabel,"black");
	printf("<input title='%s' type=text name=cLabel value=\"%s\" size=40 maxlength=32 ",
				LANG_FT_tConfiguration_cLabel,EncodeDoubleQuotes(cLabel));
	if(uPermLevel>=8 && uMode)
	{
		printf("></td></tr>\n");
	}
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=cLabel value=\"%s\">\n",
					EncodeDoubleQuotes(cLabel));
	}


	//cValue
	OpenRow(LANG_FL_tConfiguration_cValue,"black");
	printf("<input title='%s' type=text name=cValue value=\"%s\" size=40 maxlength=255 ",LANG_FT_tConfiguration_cValue,EncodeDoubleQuotes(cValue));
	if(uPermLevel>=8 && uMode)
	{
		printf("></td></tr>\n");
	}
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=cValue value=\"%s\">\n",
				EncodeDoubleQuotes(cValue));
	}

	//cComment
	OpenRow(LANG_FL_tConfiguration_cComment,"black");
	printf("<textarea title='%s' cols=80 wrap=hard rows=8 name=cComment ",
		LANG_FT_tConfiguration_cComment);
	if(uPermLevel>=8 && uMode)
	{
		printf(">%s</textarea></td></tr>\n",cComment);
	}
	else
	{
		printf("disabled>%s</textarea></td></tr>\n",cComment);
		printf("<input type=hidden name=cComment value=\"%s\">\n",
				EncodeDoubleQuotes(cComment));
	}

	//These can never be changed so we dont bother with input elements
	//uOwner
	OpenRow(LANG_FL_tConfiguration_uOwner,"black");
	printf("%s<input type=hidden name=uOwner value=%u >\n",ForeignKey("tClient","cLabel",uOwner),uOwner);

	//uCreatedBy
	OpenRow(LANG_FL_tConfiguration_uCreatedBy,"black");
	printf("%s<input type=hidden name=uCreatedBy value=%u >\n",ForeignKey("tClient","cLabel",uCreatedBy),uCreatedBy);

	//uCreatedDate
	OpenRow(LANG_FL_tConfiguration_uCreatedDate,"black");
	if(uCreatedDate)
		printf("%s\n\n",ctime(&uCreatedDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uCreatedDate value=%lu >\n",uCreatedDate);

	//uModBy
	OpenRow(LANG_FL_tConfiguration_uModBy,"black");
	printf("%s<input type=hidden name=uModBy value=%u >\n",ForeignKey("tClient","cLabel",uModBy),uModBy);

	//uModDate
	OpenRow(LANG_FL_tConfiguration_uModDate,"black");
	if(uModDate)
		printf("%s\n\n",ctime(&uModDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uModDate value=%lu >\n",uModDate);
	printf("</tr>\n");

}//void tConfigurationInput(void)


void NewtConfiguration(unsigned uMode)
{
	register int i=0;
	MYSQL_RES *res;

	//New select
	sprintf(query,"SELECT uConfiguration FROM tConfiguration\
				WHERE uConfiguration=%u"
							,uConfiguration);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	if(i) 
		//tConfiguration("<blink>Record already exists");
		tConfiguration(LANG_NBR_RECEXISTS);

	//insert query
	Insert_tConfiguration();
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	//sprintf(query,"New record %u added");
	uConfiguration=mysql_insert_id(&mysql);

	if(!uMode)
	{
	sprintf(query,LANG_NBR_NEWRECADDED,uConfiguration);
	tConfiguration(query);
	}

}//NewtConfiguration(unsigned uMode)


void DeletetConfiguration(void)
{
	sprintf(query,"DELETE FROM tConfiguration WHERE uConfiguration=%u AND ( uOwner=%u OR %u>9 )"
					,uConfiguration,uLoginClient,uPermLevel);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));

	//tConfiguration("Record Deleted");
	if(mysql_affected_rows(&mysql)>0)
		tConfiguration(LANG_NBR_RECDELETED);
	else
		tConfiguration(LANG_NBR_RECNOTDELETED);

}//void DeletetConfiguration(void)


void Insert_tConfiguration(void)
{

	time_t clock;

        time(&clock);

	sprintf(query,"INSERT INTO tConfiguration SET  uConfiguration=%u, cLabel='%s', cValue='%s', cComment='%s', uOwner=%u, uCreatedBy=%u, uCreatedDate=%lu, uModBy=%u, uModDate=0",
			uConfiguration
			,TextAreaSave(cLabel)
			,TextAreaSave(cValue)
			,TextAreaSave(cComment)
			,uOwner
			,uCreatedBy
			,(long unsigned)clock
			,uModBy
			);


	mysql_query(&mysql,query);
	uCreatedDate=clock;

}//void Insert_tConfiguration(void)


void Update_tConfiguration(char *rowid)
{
	time_t clock;

        time(&clock);

	sprintf(query,"UPDATE tConfiguration SET uConfiguration=%u,cLabel='%s',cValue='%s',cComment='%s',uModBy=%u,uModDate=%lu WHERE _rowid=%s",
			uConfiguration
			,TextAreaSave(cLabel)
			,TextAreaSave(cValue)
			,TextAreaSave(cComment)
			,uModBy
			,(long unsigned)clock
			,rowid);


	mysql_query(&mysql,query);

	uModDate=clock;

}//void Update_tConfiguration(void)


void ModtConfiguration(void)
{
	register int i=0;
	MYSQL_RES *res;
	MYSQL_ROW field;
	unsigned uPreModDate=0;

	//Mod select query
	if(uPermLevel<10)
	sprintf(query,"SELECT tConfiguration.uConfiguration,\
				tConfiguration.uModDate\
				FROM tConfiguration,tClient\
				WHERE tConfiguration.uConfiguration=%u\
				AND tConfiguration.uOwner=tClient.uClient\
				AND (tClient.uOwner=%u OR tClient.uClient=%u)"
			,uConfiguration,uLoginClient,uLoginClient);
	else
	sprintf(query,"SELECT uConfiguration,uModDate FROM tConfiguration\
				WHERE uConfiguration=%u"
						,uConfiguration);

	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	//if(i<1) tConfiguration("<blink>Record does not exist");
	if(i<1) tConfiguration(LANG_NBR_RECNOTEXIST);
	//if(i>1) tConfiguration("<blink>Multiple rows!");
	if(i>1) tConfiguration(LANG_NBR_MULTRECS);

	field=mysql_fetch_row(res);
	sscanf(field[1],"%u",&uPreModDate);
	if(uPreModDate!=uModDate) tConfiguration(LANG_NBR_EXTMOD);

	Update_tConfiguration(field[0]);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	//sprintf(query,"record %s modified",field[0]);
	sprintf(query,LANG_NBRF_REC_MODIFIED,field[0]);
	tConfiguration(query);

}//ModtConfiguration(void)


void tConfigurationList(void)
{
	MYSQL_RES *res;
	MYSQL_ROW field;

	ExttConfigurationListSelect();

	mysql_query(&mysql,query);
	if(mysql_error(&mysql)[0]) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	PageMachine("tConfigurationList",1,"");//1 is auto header list mode. Opens table!

	//Filter select drop down
	ExttConfigurationListFilter();

	printf("<input title='SQL pattern for filter on drop down field. Hit enter or [Search]' type=text size=16 name=command maxlength=98 value=\"%s\" >",command);

	printf("</table>\n");

	printf("<table bgcolor=#9BC1B3 border=0 width=100%%>\n");
	printf("<tr bgcolor=black><td><font color=white>uConfiguration<td><font color=white>cLabel<td><font color=white>cValue<td><font color=white>cComment<td><font color=white>uOwner<td><font color=white>uCreatedBy<td><font color=white>uCreatedDate<td><font color=white>uModBy<td><font color=white>uModDate</tr>");



	mysql_data_seek(res,start-1);

	for(n=0;n<(end-start+1);n++)
	{
		field=mysql_fetch_row(res);
		if(!field)
		{
			printf("<tr><td>End of data</table>");
			Footer_ism3();
		}
			if(n % 2)
				printf("<tr bgcolor=#BBE1D3>");
			else
				printf("<tr>");
		long unsigned luTime6=strtoul(field[6],NULL,10);
		char cBuf6[32];
		if(luTime6)
			ctime_r(&luTime6,cBuf6);
		else
			sprintf(cBuf6,"---");
		long unsigned luTime8=strtoul(field[8],NULL,10);
		char cBuf8[32];
		if(luTime8)
			ctime_r(&luTime8,cBuf8);
		else
			sprintf(cBuf8,"---");
			
		printf("<td><input type=submit name=ED%s value=Edit> %s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s</tr>"
			,field[0]
			,field[0]
			,field[1]
			,field[2]
			,field[3]
			,ForeignKey("tClient","cLabel",strtoul(field[4],NULL,10))
			,ForeignKey("tClient","cLabel",strtoul(field[5],NULL,10))
			,cBuf6
			,ForeignKey("tClient","cLabel",strtoul(field[7],NULL,10))
			,cBuf8
				);

	}

	CloseFieldSet();
	Footer_ism3();

}//tConfigurationList()


void CreatetConfiguration(void)
{
	sprintf(query,"CREATE TABLE tConfiguration ( cComment text NOT NULL DEFAULT '', uConfiguration int unsigned NOT NULL PRIMARY KEY AUTO_INCREMENT, cLabel varchar(32) NOT NULL DEFAULT '', UNIQUE (cLabel), uOwner int unsigned NOT NULL DEFAULT 0,index (uOwner), uCreatedBy int unsigned NOT NULL DEFAULT 0, uCreatedDate int unsigned NOT NULL DEFAULT 0, uModBy int unsigned NOT NULL DEFAULT 0, uModDate int unsigned NOT NULL DEFAULT 0, cValue varchar(255) NOT NULL DEFAULT '' )");
	mysql_query(&mysql,qstr);
	if(mysql_errno(&mysql))
		mysqlBind(mysql_error(&mysql));
}//CreatetConfiguration()

