/*
FILE
	$Id: tnameserverfunc.h 52 2006-08-26 14:31:43Z ggw $
PURPOSE
	Non-schema dependent tnameserver.c expansion.
AUTHOR
	GPL License applies, see www.fsf.org for details
	See LICENSE file in this distribution
	(C) 2001-2004 Gary Wallis.
*/

static char cTarget[100]={""};
//bind.c
void Status(char *cTarget, char *cLabel);

void tNameServerNavList(void);

void ExtProcesstNameServerVars(pentry entries[], int x)
{

	register int i;
	
	for(i=0;i<x;i++)
	{
		if(!strcmp(entries[i].name,"cTarget"))
		{
			strncpy(cTarget,FQDomainName(entries[i].val),99);
			cTarget[99]=0;
		}
	}

}//void ExtProcesstNameServerVars(pentry entries[], int x)


void ExttNameServerCommands(pentry entries[], int x)
{
	if(!strcmp(function,"tNameServerTools"))
	{
		if(!strcmp(command,LANG_NB_NEW))
                {
			if(uPermLevel>=12)
			{
                	        ProcesstNameServerVars(entries,x);
				//Check global conditions for new record here
				mode=2000;
				tNameServer(LANG_NB_CONFIRMNEW);
			}
                }
		else if(!strcmp(command,LANG_NB_CONFIRMNEW))
                {
			if(uPermLevel>=12)
			{
				ProcesstNameServerVars(entries,x);
				//Check entries here
				if(cList[strlen(cList)-1]!='\n')
					strcat(cList,"\n");
				uNameServer=0;
				uCreatedBy=uLoginClient;
				uOwner=uLoginClient;
				uModBy=0;//Never modified
				NewtNameServer(0);
			}
		}
		else if(!strcmp(command,LANG_NB_DELETE))
                {
                        ProcesstNameServerVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=12 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				mode=2001;
				tNameServer(LANG_NB_CONFIRMDEL);
			}
                }
                else if(!strcmp(command,LANG_NB_CONFIRMDEL))
                {
                        ProcesstNameServerVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=12 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				mode=5;
				DeletetNameServer();
			}
                }
		else if(!strcmp(command,LANG_NB_MODIFY))
                {
                        ProcesstNameServerVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=10 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				mode=2002;
				tNameServer(LANG_NB_CONFIRMMOD);
			}
                }
                else if(!strcmp(command,LANG_NB_CONFIRMMOD))
                {
                        ProcesstNameServerVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=10 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				uModBy=uLoginClient;
				//Hack: Fix the reader algo someday
				if(cList[strlen(cList)-1]!='\n')
					strcat(cList,"\n");
				ModtNameServer();
			}
                }
                else if(!strcmp(command,"Check"))
		{
                        ProcesstNameServerVars(entries,x);
			if(uPermLevel>=10)
				Status(cTarget,cLabel);
		}
	}

}//void ExttNameServerCommands(pentry entries[], int x)


void ExttNameServerButtons(void)
{
	OpenFieldSet("Aux Panel",100);
	
	switch(mode)
        {
                case 2000:
			printf("Enter required data<br>");
                        printf(LANG_NBB_CONFIRMNEW);
			printf("<br>\n");
                break;

                case 2001:
                        printf(LANG_NBB_CONFIRMDEL);
			printf("<br>\n");
                break;

                case 2002:
			printf("Review record data<br>");
                        printf(LANG_NBB_CONFIRMMOD);
			printf("<br>\n");
                break;

		default:
			if(uPermLevel>=10)
			{
				printf("<p><u>Check Name Servers</u><br>\n");
				printf("<input title='Optional: Check specified group against this NS (dig @). Default is 127.0.0.1' type=text name=cTarget value='%s' maxlength=99 size=20>",
						cTarget);
				printf("<br>");
				printf("<input class=largeButton title='Check current NS group with dig against optional NS specified above.' type=submit name=command value='Check'>");

			}
			tNameServerNavList();
	}


	CloseFieldSet();


}//void ExttNameServerButtons(void)


void ExttNameServerAuxTable(void)
{

}//void ExttNameServerAuxTable(void)


void ExttNameServerGetHook(entry gentries[], int x)
{
	register int i;

	for(i=0;i<x;i++)
	{
		if(!strcmp(gentries[i].name,"uNameServer"))
		{
			sscanf(gentries[i].val,"%u",&uNameServer);
			mode=6;
		}
	}
	tNameServer("");

}//void ExttNameServerGetHook(entry gentries[], int x)


void ExttNameServerSelect(void)
{
        //Set non search query here for tTableName()
	if(uPermLevel>=9)
	sprintf(query,"SELECT %s FROM tNameServer ORDER BY uNameServer",
					VAR_LIST_tNameServer);
	else
	sprintf(query,"SELECT %s FROM tNameServer WHERE uOwner=%u ORDER BY uNameServer",
					VAR_LIST_tNameServer,uLoginClient);

}//void ExttNameServerSelect(void)


void ExttNameServerSelectRow(void)
{
	if(uPermLevel<10)
                sprintf(query,"SELECT %s FROM tNameServer,tClient \
                                WHERE tNameServer.uOwner=tClient.uClient\
                                AND (tClient.uOwner=%u OR tClient.uClient=%u)\
                                AND tNameServer.uNameServer=%u",
                        		VAR_LIST_tNameServer,
					uLoginClient,uLoginClient,uNameServer);
	else
                sprintf(query,"SELECT %s FROM tNameServer WHERE uNameServer=%u",
			VAR_LIST_tNameServer,uNameServer);

}//void ExttNameServerSelectRow(void)


void ExttNameServerListSelect(void)
{
	char cCat[512];

	if(uPermLevel<10)
		sprintf(query,"SELECT %s FROM tNameServer,tClient \
		WHERE tNameServer.uOwner=tClient.uClient \
		AND (tClient.uOwner=%u OR tClient.uClient=%u)",
				VAR_LIST_tNameServer,
				uLoginClient,
				uLoginClient);
	else
                sprintf(query,"SELECT %s FROM tNameServer",
				VAR_LIST_tNameServer);

	//Changes here must be reflected below in ExttNameServerListFilter()
        if(!strcmp(filter,"uNameServer"))
        {
                sscanf(command,"%u",&uNameServer);
		if(uPermLevel<10)
			strcat(query," AND ");
		else
			strcat(query," WHERE ");
		sprintf(cCat,"tNameServer.uNameServer=%u \
						ORDER BY uNameServer",
						uNameServer);
		strcat(query,cCat);
        }
        else if(1)
        {
                //None NO FILTER
                strcpy(filter,"None");
		strcat(query," ORDER BY uNameServer");
        }

}//void ExttNameServerListSelect(void)


void ExttNameServerListFilter(void)
{
        //Filter
        printf("<td align=right >Select ");
        printf("<select name=filter>");
        if(strcmp(filter,"uNameServer"))
                printf("<option>uNameServer</option>");
        else
                printf("<option selected>uNameServer</option>");
        if(strcmp(filter,"None"))
                printf("<option>None</option>");
        else
                printf("<option selected>None</option>");
        printf("</select>");

}//void ExttNameServerListFilter(void)


void ExttNameServerNavBar(void)
{
	if(uOwner) GetClientOwner(uOwner,&uReseller);

	printf(LANG_NBB_SKIPFIRST);
	printf(LANG_NBB_SKIPBACK);
	printf(LANG_NBB_SEARCH);

	if(uPermLevel>=12)
		printf(LANG_NBB_NEW);

	if( (uPermLevel>=10 && uOwner==uLoginClient)
			|| (uPermLevel>9 && uOwner!=1)
			|| (uPermLevel>7 && uReseller==uLoginClient) )
		printf(LANG_NBB_MODIFY);

	if( (uPermLevel>=12 && uOwner==uLoginClient)
			|| (uPermLevel>9 && uOwner!=1)
			|| (uPermLevel>7 && uReseller==uLoginClient) )
		printf(LANG_NBB_DELETE);

	printf(LANG_NBB_LIST);

	printf(LANG_NBB_SKIPNEXT);
	printf(LANG_NBB_SKIPLAST);

}//void ExttNameServerNavBar(void)


void tNameServerNavList(void)
{
        MYSQL_RES *res;
        MYSQL_ROW field;

	if(uPermLevel<10)
		sprintf(query,"SELECT tNameServer.uNameServer\
				,tNameServer.cLabel\
				FROM tNameServer,tClient\
                                WHERE tNameServer.uOwner=tClient.uClient\
                                AND (tClient.uOwner=%u OR tClient.uClient=%u)",
					uLoginClient,uLoginClient);
	else
	        sprintf(query,"SELECT uNameServer,cLabel FROM tNameServer");

        mysql_query(&mysql,query);
        if(mysql_errno(&mysql))
        {
        	printf("<p><u>tNameServerNavList</u><br>\n");
                printf("%s<br>\n",mysql_error(&mysql));
                return;
        }

        res=mysql_store_result(&mysql);
	if(mysql_num_rows(res))
	{
		printf("<p><u>tNameServerNavList</u><br>\n");
		while((field=mysql_fetch_row(res)))
        	{
			printf("<a class=darkLink href=mysqlBind.cgi?function=tNameServer&uNameServer=%s>%s</a><br>\n",field[0],field[1]);
        	}
	}
        mysql_free_result(res);

}//void tNameServerNavList(void)


// vim:tw=78
