/*
FILE
	tZone source code of mysqlBind.cgi
	(built by mysqlRAD2.cgi (c) Gary Wallis 2001,2002 GPL Licensed)
	$Id: tzone.c 54 2006-09-07 16:17:08Z root $
	(tAuthorize.cPasswd template set member)
PURPOSE
*/

#include "mysqlrad.h"

//Table Variables
//uZone: Primary Key
static unsigned uZone=0;
//cZone: Zone name
static char cZone[101]={"domain.tld"};
//uNameServer: Pulldown of configured name server groups
static unsigned uNameServer=0;
static char cuNameServerPullDown[256]={""};
//cHostmaster: eMail address of responsible person
static char cHostmaster[101]={""};
//uSerial: Zone serial number
static unsigned uSerial=0;
//uExpire: Seconds to expire for slave name servers
static unsigned uExpire=604800;
//uRefresh: How often slaves should contact master
static unsigned uRefresh=28800;
//uTTL: Default minimum TTL for RRs
static unsigned uTTL=86400;
//uRetry: Slave server retry interval after uRefresh
static unsigned uRetry=7200;
//uZoneTTL: Zone TTL
static unsigned uZoneTTL=86400;
//uMailServers: Pulldown of configured mail server groups
static unsigned uMailServers=0;
static char cuMailServersPullDown[256]={""};
//cMainAddress: Zones main A record
static char cMainAddress[17]={""};
//uOwner: Record owner
static unsigned uOwner=0;
//uCreatedBy: uClient for last insert
static unsigned uCreatedBy=0;
#define ISM3FIELDS
//uCreatedDate: Unix seconds date last insert
static long unsigned uCreatedDate=0;
//uModBy: uClient for last update
static unsigned uModBy=0;
//uModDate: Unix seconds date last update
static long unsigned uModDate=0;




#define VAR_LIST_tZone "tZone.uZone,tZone.cZone,tZone.uNameServer,tZone.cHostmaster,tZone.uSerial,tZone.uExpire,tZone.uRefresh,tZone.uTTL,tZone.uRetry,tZone.uZoneTTL,tZone.uMailServers,tZone.cMainAddress,tZone.uOwner,tZone.uCreatedBy,tZone.uCreatedDate,tZone.uModBy,tZone.uModDate"

 //Local only
void Insert_tZone(void);
void Update_tZone(char *rowid);
int InsertUpdate_tZone(char *cKey);
void ProcesstZoneListVars(pentry entries[], int x);

 //In tZonefunc.h file included below
void ExtProcesstZoneVars(pentry entries[], int x);
void ExttZoneCommands(pentry entries[], int x);
void ExttZoneButtons(void);
void ExttZoneNavBar(void);
void ExttZoneGetHook(entry gentries[], int x);
void ExttZoneSelect(void);
void ExttZoneSelectRow(void);
void ExttZoneListSelect(void);
void ExttZoneListFilter(void);
void ExttZoneAuxTable(void);

#include "tzonefunc.h"

 //Table Variables Assignment Function
void ProcesstZoneVars(pentry entries[], int x)
{
	register int i;


	for(i=0;i<x;i++)
	{
		if(!strcmp(entries[i].name,"uZone"))
			sscanf(entries[i].val,"%u",&uZone);
		else if(!strcmp(entries[i].name,"cZone"))
			sprintf(cZone,"%.100s",FQDomainName(entries[i].val));
		else if(!strcmp(entries[i].name,"uNameServer"))
			sscanf(entries[i].val,"%u",&uNameServer);
		else if(!strcmp(entries[i].name,"cuNameServerPullDown"))
		{
			sprintf(cuNameServerPullDown,"%.255s",entries[i].val);
			uNameServer=ReadPullDown("tNameServer","cLabel",cuNameServerPullDown);
		}
		else if(!strcmp(entries[i].name,"cHostmaster"))
			sprintf(cHostmaster,"%.100s",FQDomainName(entries[i].val));
		else if(!strcmp(entries[i].name,"uSerial"))
			sscanf(entries[i].val,"%u",&uSerial);
		else if(!strcmp(entries[i].name,"uExpire"))
			sscanf(entries[i].val,"%u",&uExpire);
		else if(!strcmp(entries[i].name,"uRefresh"))
			sscanf(entries[i].val,"%u",&uRefresh);
		else if(!strcmp(entries[i].name,"uTTL"))
			sscanf(entries[i].val,"%u",&uTTL);
		else if(!strcmp(entries[i].name,"uRetry"))
			sscanf(entries[i].val,"%u",&uRetry);
		else if(!strcmp(entries[i].name,"uZoneTTL"))
			sscanf(entries[i].val,"%u",&uZoneTTL);
		else if(!strcmp(entries[i].name,"uMailServers"))
			sscanf(entries[i].val,"%u",&uMailServers);
		else if(!strcmp(entries[i].name,"cuMailServersPullDown"))
		{
			sprintf(cuMailServersPullDown,"%.255s",entries[i].val);
			uMailServers=ReadPullDown("tMailServer","cLabel",cuMailServersPullDown);
		}
		else if(!strcmp(entries[i].name,"cMainAddress"))
			sprintf(cMainAddress,"%.16s",IPNumber(entries[i].val));
		else if(!strcmp(entries[i].name,"uOwner"))
			sscanf(entries[i].val,"%u",&uOwner);
		else if(!strcmp(entries[i].name,"uCreatedBy"))
			sscanf(entries[i].val,"%u",&uCreatedBy);
		else if(!strcmp(entries[i].name,"uCreatedDate"))
			sscanf(entries[i].val,"%lu",&uCreatedDate);
		else if(!strcmp(entries[i].name,"uModBy"))
			sscanf(entries[i].val,"%u",&uModBy);
		else if(!strcmp(entries[i].name,"uModDate"))
			sscanf(entries[i].val,"%lu",&uModDate);

	}

	//After so we can overwrite form data if needed.
	ExtProcesstZoneVars(entries,x);

}//ProcesstZoneVars()


void ProcesstZoneListVars(pentry entries[], int x)
{
        register int i;

        for(i=0;i<x;i++)
        {
                if(!strncmp(entries[i].name,"ED",2))
                {
                        sscanf(entries[i].name+2,"%u",&uZone);
                        mode=6;
                        tZone("");
                }
        }
}//void ProcesstZoneListVars(pentry entries[], int x)


int tZoneCommands(pentry entries[], int x)
{
	ProcessControlVars(entries,x);

	ExttZoneCommands(entries,x);

	if(!strcmp(function,"tZoneTools"))
	{
		if(!strcmp(find,LANG_NB_LIST))
		{
			tZoneList();
		}

		//Default
		ProcesstZoneVars(entries,x);
		tZone("");
	}
	else if(!strcmp(function,"tZoneList"))
	{
		ProcessControlVars(entries,x);
		ProcesstZoneListVars(entries,x);
		tZoneList();
	}

	return(0);

}//tZoneCommands()


void tZone(const char *result)
{
	MYSQL_RES *res;
	MYSQL_RES *res2;
	MYSQL_ROW field;

	//Internal skip reloading
	if(!result[0])
	{
		if(mode)
			ExttZoneSelectRow();
		else
			ExttZoneSelect();

		mysql_query(&mysql,query);
		if(mysql_errno(&mysql))
        	{
			if(strstr(mysql_error(&mysql)," doesn't exist"))
                	{
				CreatetZone();
				mysqlBind("New tZone table created");
                	}
			else
			{
				mysqlBind(mysql_error(&mysql));
			}
        	}

		res=mysql_store_result(&mysql);
		if((i=mysql_num_rows(res)))
		{
			if(mode==6)
			{
			sprintf(query,"SELECT _rowid FROM tZone WHERE uZone=%u"
						,uZone);
			mysql_query(&mysql,query);
			res2=mysql_store_result(&mysql);
			field=mysql_fetch_row(res2);
			sscanf(field[0],"%lu",&rowid);
			rowid++;
			}
			PageMachine("",0,"");
			if(!mode) mysql_data_seek(res,rowid-1);
			field=mysql_fetch_row(res);
		sscanf(field[0],"%u",&uZone);
		sprintf(cZone,"%.100s",field[1]);
		sscanf(field[2],"%u",&uNameServer);
		sprintf(cHostmaster,"%.100s",field[3]);
		sscanf(field[4],"%u",&uSerial);
		sscanf(field[5],"%u",&uExpire);
		sscanf(field[6],"%u",&uRefresh);
		sscanf(field[7],"%u",&uTTL);
		sscanf(field[8],"%u",&uRetry);
		sscanf(field[9],"%u",&uZoneTTL);
		sscanf(field[10],"%u",&uMailServers);
		sprintf(cMainAddress,"%.16s",field[11]);
		sscanf(field[12],"%u",&uOwner);
		sscanf(field[13],"%u",&uCreatedBy);
		sscanf(field[14],"%lu",&uCreatedDate);
		sscanf(field[15],"%u",&uModBy);
		sscanf(field[16],"%lu",&uModDate);

		}

	}//Internal Skip

	Header_ism3(":: tZone",0);
	
	printf("<table width=100%% cellspacing=0 cellpadding=0>\n");
	printf("<tr><td colspan=2 align=right valign=center>");
	


	printf("<input type=hidden name=function value=tZoneTools>");
	printf("<input type=hidden name=rowid value=%lu>",rowid);
	if(i)
	{
		if(mode==6)
			//printf(" Found");
			printf(LANG_NBR_FOUND);
		else if(mode==5)
			//printf(" Modified");
			printf(LANG_NBR_MODIFIED);
		else if(mode==4)
			//printf(" New");
			printf(LANG_NBR_NEW);
		printf(LANG_NBRF_SHOWING,rowid,i);
	}
	else
	{
		if(!result[0])
		//printf(" No records found");
		printf(LANG_NBR_NORECS);
	}
	if(result[0]) printf("%s",result);
	printf("</td></tr>");
	printf("<tr><td valign=top width=25%%>");

        ExttZoneButtons();

        printf("</td><td valign=top>");
	OpenFieldSet("Record Data",100);

	if(mode==2000 || mode==2002)
		tZoneInput(1);
	else
		tZoneInput(0);

	CloseFieldSet();
	//Bottom table
	printf("<tr><td colspan=2>");
        ExttZoneAuxTable();

	Footer_ism3();

}//end of tZone();


void tZoneInput(unsigned uMode)
{

	//uZone
	OpenRow(LANG_FL_tZone_uZone,"black");
	printf("<input title='%s' type=text name=uZone value=%u size=16 maxlength=10 ",LANG_FT_tZone_uZone,uZone);
	if(uPermLevel>=20 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=uZone value=%u >\n",uZone);
	}

	//cZone
	OpenRow(LANG_FL_tZone_cZone,"black");
	printf("<input title='%s' type=text name=cZone value=\"%s\" size=40 maxlength=99 ",LANG_FT_tZone_cZone,EncodeDoubleQuotes(cZone));
	if(uPermLevel>=7 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=cZone value=\"%s\">",EncodeDoubleQuotes(cZone));
	}
	
	//cuNameserver
	OpenRow("uNameServer","black");	
	if(uPermLevel>=7 && uMode)
		tTablePullDown("tNameServer;cuNameServerPullDown","cLabel","cLabel",uNameServer);
	else
	{
		tTablePullDownReadOnly("tNameServer;cuNameServerPullDown","cLabel","cLabel",uNameServer);
	}
	
	//cHostmaster
	OpenRow(LANG_FL_tZone_cHostmaster,"black");
	printf("<input title='%s' type=text name=cHostmaster value=\"%s\" size=40 maxlength=100 ",LANG_FT_tZone_cHostmaster,EncodeDoubleQuotes(cHostmaster));
	if(uPermLevel>=7 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=cHostmaster value=\"%s\">",EncodeDoubleQuotes(cHostmaster));
	}

	//uSerial
	OpenRow(LANG_FL_tZone_uSerial,"black");
	printf("<input title='%s' type=text name=uSerial value=%u size=16 maxlength=10 ",LANG_FT_tZone_uSerial,uSerial);
	if(uPermLevel>=7 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=uSerial value=\"%i\">",uSerial);
	}

	//uTTL
	OpenRow(LANG_FL_tZone_uTTL,"black");
	printf("<input title='%s' type=text name=uTTL value=%u size=16 maxlength=10\n",LANG_FT_tZone_uTTL,uTTL);
	if(uPermLevel>=7 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=uTTL value=\"%u\">",uTTL);
	}

	//uZoneTTL
	OpenRow(LANG_FL_tZone_uZoneTTL,"black");
	printf("<input title='%s' type=text name=uZoneTTL value=%u size=16 maxlength=10\n",LANG_FT_tZone_uZoneTTL,uZoneTTL);
	if(uPermLevel>=7 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=uZoneTTL value=\"%u\">",uZoneTTL);
	}

	//uRefresh
	OpenRow(LANG_FL_tZone_uRefresh,"black");
	printf("<input title='%s' type=text name=uRefresh value=%u size=16 maxlength=10\n",LANG_FT_tZone_uRefresh,uRefresh);
	if(uPermLevel>=7 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=uRefresh value=\"%u\">",uRefresh);
	}

	//uExpire
	OpenRow(LANG_FL_tZone_uExpire,"black");
	printf("<input title='%s' type=text name=uExpire value=%u size=16 maxlength=10\n",LANG_FT_tZone_uExpire,uExpire);
	if(uPermLevel>=7 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=uExpire value=\"%u\">",uExpire);
	}

	//uRetry
	OpenRow(LANG_FL_tZone_uRetry,"black");
	printf("<input title='%s' type=text name=uRetry value=%u size=16 maxlength=10\n",LANG_FT_tZone_uRetry,uRetry);
	if(uPermLevel>=7 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=uRetry value=\"%u\">",uRetry);
	}

	//uMailServers
	OpenRow(LANG_FL_tZone_uMailServers,"black");
	if(uPermLevel>=7 && uMode)
		tTablePullDown("tMailServer;cuMailServersPullDown","cLabel","cLabel",uMailServers);
	else
	{
		tTablePullDownReadOnly("tMailServer;cuMailServersPullDown","cLabel","cLabel",uMailServers);
	}
	printf("</tr>\n");

	OpenRow(LANG_FL_tZone_cMainAddress,"black");
	printf("<input title='%s' type=text name=cMainAddress value=\"%s\" size=40 maxlength=16 ",LANG_FT_tZone_cMainAddress,EncodeDoubleQuotes(cMainAddress));
	if(uPermLevel>=7 && uMode)
		printf("></td></tr>\n");
	else
	{
		printf("disabled></td></tr>\n");
		printf("<input type=hidden name=cMainAddress value=\"%s\">",EncodeDoubleQuotes(cMainAddress));		
	}

	//uOwner
	OpenRow(LANG_FL_tZone_uOwner,"black");
	printf("%s<input type=hidden name=uOwner value=%u >\n",ForeignKey("tClient","cLabel",uOwner),uOwner);

	//uCreatedBy
	OpenRow(LANG_FL_tZone_uCreatedBy,"black");
	printf("%s<input type=hidden name=uCreatedBy value=%u >\n",ForeignKey("tClient","cLabel",uCreatedBy),uCreatedBy);

	//uCreatedDate
	OpenRow(LANG_FL_tZone_uCreatedDate,"black");
	if(uCreatedDate)
		printf("%s\n\n",ctime(&uCreatedDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uCreatedDate value=%lu >\n",uCreatedDate);

	//uModBy
	OpenRow(LANG_FL_tZone_uModBy,"black");
	printf("%s<input type=hidden name=uModBy value=%u >\n",ForeignKey("tClient","cLabel",uModBy),uModBy);

	//uModDate
	OpenRow(LANG_FL_tZone_uModDate,"black");
	if(uModDate)
		printf("%s\n\n",ctime(&uModDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uModDate value=%lu >\n",uModDate);
	printf("</tr>\n");

}//void tZoneInputContent(void)


void NewtZone(unsigned uMode)
{
	register int i=0;
	MYSQL_RES *res;

	//New select
	sprintf(query,"SELECT uZone FROM tZone\
				WHERE uZone=%u"
							,uZone);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	if(i) 
		//tZone("<blink>Record already exists");
		tZone(LANG_NBR_RECEXISTS);

	//insert query
	Insert_tZone();
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	//sprintf(query,"New record %u added");
	uZone=mysql_insert_id(&mysql);

	if(!uMode)
	{
	sprintf(query,LANG_NBR_NEWRECADDED,uZone);
	tZone(query);
	}

}//NewtZone(unsigned uMode)


void DeletetZone(void)
{
#ifdef ISM3FIELDS
	sprintf(query,"DELETE FROM tZone WHERE uZone=%u AND ( uOwner=%u OR %u>9 )"
					,uZone,uLoginClient,uPermLevel);
#else
	sprintf(query,"DELETE FROM tZone WHERE uZone=%u"
					,uZone);
#endif
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));

	//tZone("Record Deleted");
	if(mysql_affected_rows(&mysql)>0)
		tZone(LANG_NBR_RECDELETED);
	else
		tZone(LANG_NBR_RECNOTDELETED);

}//void DeletetZone(void)


void Insert_tZone(void)
{

#ifdef ISM3FIELDS
	time_t clock;

        time(&clock);
#endif

	//insert query

	//insert query
	sprintf(query,"INSERT INTO tZone SET  uZone=%u, cZone='%s', uNameServer=%u, cHostmaster='%s', uSerial=%u, uExpire=%u, uRefresh=%u, uTTL=%u, uRetry=%u, uZoneTTL=%u, uMailServers=%u, cMainAddress='%s', uOwner=%u, uCreatedBy=%u, uCreatedDate=%lu, uModBy=%u, uModDate=0",
			uZone
			,TextAreaSave(cZone)
			,uNameServer
			,TextAreaSave(cHostmaster)
			,uSerial
			,uExpire
			,uRefresh
			,uTTL
			,uRetry
			,uZoneTTL
			,uMailServers
			,TextAreaSave(cMainAddress)
			,uOwner
			,uCreatedBy
			,(long unsigned)clock
			,uModBy
			);


	mysql_query(&mysql,query);
#ifdef ISM3FIELDS
	uCreatedDate=clock;
#endif

}//void Insert_tZone(void)


void Update_tZone(char *rowid)
{
#ifdef ISM3FIELDS
	time_t clock;

        time(&clock);
#endif

	//update query

	//update query
	sprintf(query,"UPDATE tZone SET uZone=%u,cZone='%s',uNameServer=%u,cHostmaster='%s',uSerial=%u,uExpire=%u,uRefresh=%u,uTTL=%u,uRetry=%u,uZoneTTL=%u,uMailServers=%u,cMainAddress='%s',uModBy=%u,uModDate=%lu WHERE _rowid=%s",
			uZone
			,TextAreaSave(cZone)
			,uNameServer
			,TextAreaSave(cHostmaster)
			,uSerial
			,uExpire
			,uRefresh
			,uTTL
			,uRetry
			,uZoneTTL
			,uMailServers
			,TextAreaSave(cMainAddress)
			,uModBy
			,(long unsigned)clock
			,rowid);


	mysql_query(&mysql,query);

#ifdef ISM3FIELDS
	uModDate=clock;
#endif

}//void Update_tZone(void)


void ModtZone(void)
{
	register int i=0;
	MYSQL_RES *res;
	MYSQL_ROW field;
#ifdef ISM3FIELDS
	unsigned uPreModDate=0;

	//Mod select query
	if(uPermLevel<10)
	sprintf(query,"SELECT tZone.uZone,\
				tZone.uModDate\
				FROM tZone,tClient\
				WHERE tZone.uZone=%u\
				AND tZone.uOwner=tClient.uClient\
				AND (tClient.uOwner=%u OR tClient.uClient=%u)"
			,uZone,uLoginClient,uLoginClient);
	else
	sprintf(query,"SELECT uZone,uModDate FROM tZone\
				WHERE uZone=%u"
						,uZone);
#else
	sprintf(query,"SELECT uZone FROM tZone\
				WHERE uZone=%u"
						,uZone);
#endif

	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	//if(i<1) tZone("<blink>Record does not exist");
	if(i<1) tZone(LANG_NBR_RECNOTEXIST);
	//if(i>1) tZone("<blink>Multiple rows!");
	if(i>1) tZone(LANG_NBR_MULTRECS);

	field=mysql_fetch_row(res);
#ifdef ISM3FIELDS
	sscanf(field[1],"%u",&uPreModDate);
	if(uPreModDate!=uModDate) tZone(LANG_NBR_EXTMOD);
#endif

	Update_tZone(field[0]);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	//sprintf(query,"record %s modified",field[0]);
	sprintf(query,LANG_NBRF_REC_MODIFIED,field[0]);
	tZone(query);

}//ModtZone(void)


void tZoneList(void)
{
	MYSQL_RES *res;
	MYSQL_ROW field;

	ExttZoneListSelect();

	mysql_query(&mysql,query);
	if(mysql_error(&mysql)[0]) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	PageMachine("tZoneList",1,"");//1 is auto header list mode. Opens table!

	//Filter select drop down
	ExttZoneListFilter();

	printf("<input type=text size=16 name=command maxlength=98 value=\"%s\" >",command);

	printf("</table>\n");

	printf("<table bgcolor=#9BC1B3 border=0 width=100%%>\n");
	printf("<tr bgcolor=black><td><font color=white>uZone<td><font color=white>cZone<td><font color=white>uNameServer<td><font color=white>cHostmaster<td><font color=white>uSerial<td><font color=white>uExpire<td><font color=white>uRefresh<td><font color=white>uTTL<td><font color=white>uRetry<td><font color=white>uZoneTTL<td><font color=white>uMailServers<td><font color=white>cMainAddress<td><font color=white>uOwner<td><font color=white>uCreatedBy<td><font color=white>uCreatedDate<td><font color=white>uModBy<td><font color=white>uModDate</tr>");



	mysql_data_seek(res,start-1);

	for(n=0;n<(end-start+1);n++)
	{
		field=mysql_fetch_row(res);
		if(!field)
		{
			printf("<tr><td>End of data</table>");
			Footer_ism3();
		}
			if(n % 2)
				printf("<tr bgcolor=#BBE1D3>");
			else
				printf("<tr>");
		long unsigned luTime14=strtoul(field[14],NULL,10);
		char cBuf14[32];
		if(luTime14)
			ctime_r(&luTime14,cBuf14);
		else
			sprintf(cBuf14,"---");
		long unsigned luTime16=strtoul(field[16],NULL,10);
		char cBuf16[32];
		if(luTime16)
			ctime_r(&luTime16,cBuf16);
		else
			sprintf(cBuf16,"---");
		
		printf("<td><input type=submit name=ED%s value=Edit> %s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s</tr>"
			,field[0]
			,field[0]
			,field[1]
			,ForeignKey("tNameServer","cLabel",strtoul(field[2],NULL,10))
			,field[3]
			,field[4]
			,field[5]
			,field[6]
			,field[7]
			,field[8]
			,field[9]
			,ForeignKey("tMailServer","cLabel",strtoul(field[10],NULL,10))
			,field[11]
			,ForeignKey("tClient","cLabel",strtoul(field[12],NULL,10))
			,ForeignKey("tClient","cLabel",strtoul(field[13],NULL,10))
			,cBuf14
			,ForeignKey("tClient","cLabel",strtoul(field[15],NULL,10))
			,cBuf16
				);

	}
	printf("</table></form>\n");
	Footer_ism3();

}//tZoneList()


void CreatetZone(void)
{
	sprintf(query,"CREATE TABLE tZone ( uZone int unsigned NOT NULL PRIMARY KEY AUTO_INCREMENT, cZone varchar(100) NOT NULL DEFAULT '', UNIQUE (cZone), uOwner int unsigned NOT NULL DEFAULT 0,index (uOwner), uCreatedBy int unsigned NOT NULL DEFAULT 0, uCreatedDate int unsigned NOT NULL DEFAULT 0, uModBy int unsigned NOT NULL DEFAULT 0, uModDate int unsigned NOT NULL DEFAULT 0, uNameServer int unsigned NOT NULL DEFAULT 0,index (uNameServer), cHostmaster varchar(100) NOT NULL DEFAULT '', uSerial int unsigned NOT NULL DEFAULT 0, uExpire int unsigned NOT NULL DEFAULT 0, uRefresh int unsigned NOT NULL DEFAULT 0, uTTL int unsigned NOT NULL DEFAULT 0, uRetry int unsigned NOT NULL DEFAULT 0, uZoneTTL int unsigned NOT NULL DEFAULT 0, uMailServers int unsigned NOT NULL DEFAULT 0, cMainAddress varchar(16) NOT NULL DEFAULT '' )");
	mysql_query(&mysql,qstr);
	if(mysql_errno(&mysql))
		mysqlBind(mysql_error(&mysql));
}//CreatetZone()

